package game

import (
	"encoding/json"
	"fmt"
	"os"
	"sirlab.de/go/knyt/engine"
)

func NewGameFromFile(id, fileName string) (*Game, error) {
	jsonBytes, err := os.ReadFile(fileName)
	if err != nil {
		return nil, err
	}

	var gm Game
	if err := json.Unmarshal(jsonBytes, &gm); err != nil {
		return nil, fmt.Errorf("%s: %v\n", fileName, err)
	} else {
		gm.id = id
		gm.eng = engine.NewEngine(id)
		go gm.eng.Run()
		return &gm, nil
	}
}

func (gm *Game) GetId() string {
	return gm.id
}

func (gm *Game) GetEngine() *engine.Engine {
	return gm.eng
}
